<template>
    <form @submit.prevent="saveCustomer">
      <card>
    
        <h5 slot="header" class="title">{{ this.title }}</h5>
        
        <!-- First row -->
        <div class="row">
          <div class="col-md-6 pr-md-1">
            <base-input label="Nome" v-model="model.name" :class="{ 'has-danger': $v.model.name.$error }">
              <!-- Input Name -->
            </base-input>
          </div>
    
          <div class="col-md-6 pl-md-1">
            <base-input label="CPF" v-model="model.document" :class="{ 'has-danger': $v.model.document.$error }" v-mask="'###.###.###-##'">
              <!-- Input document -->
            </base-input>
          </div>
        </div>
        <!-- ... -->
    
        <!-- Second row -->
        <div class="row">
    
          <div class="col-md-4">
            <base-input label="Telefone" v-model="model.phone" :class="{ 'has-danger': $v.model.phone.$error }" v-mask="['(##) ####-####', '(##) #####-####']">
              <!-- Input phone -->
            </base-input>
          </div>
    
          <div class="col-md-4 pl-md-1">
            <base-input label="Numero de contrato" v-model.number="model.contractNumber" type="number" min="1" :class="{ 'has-danger': $v.model.contractNumber.$error }" @keypress="isNumber($event)">
              <!-- Input contractNumber -->
            </base-input>
          </div>
    
          <div class="col-md-4 pl-md-1">
            <base-input label="Data do contrato" v-model="model.contractDate" v-mask="['##/##/####']"  :class="{ 'has-danger': $v.model.contractDate.$error }">
            </base-input>
          </div>
    
        </div>
        <!-- ... -->
    
        <!-- Third row -->
        <div class="row">
    
          <div class="col-md-4 pr-md-1">
            <base-input label="Valor do contrato" v-model="model.contractValue" :class="{ 'has-danger': $v.model.contractValue.$error }">
              <!-- Contract value-->
            </base-input>
          </div>
    
          <div class="col-md-4 px-md-1">
            <base-input label="Situacao do contrato" :class="{ 'has-danger': $v.model.contractStatus.$error }">
              <select class="form-control" v-model="model.contractStatus" >
                <option style="color: black;" value="">Selecione</option>
                <option 
                  class="text-capitalize"
                  style="color: black;" 
                  v-for="(label, status) in contractStates" :value="status"
                >{{label}}</option>
              </select>
            </base-input>
          </div>
    
          <div class="col-md-4 pl-md-1">
            <base-input label="Ação" :class="{ 'has-danger': $v.model.action.$error }">
              <select class="form-control" v-model="model.action" >
                <option style="color: black;" value="">Selecione</option>
                <option 
                  class="text-capitalize"
                  style="color: black;" 
                  v-for="(label, action) in actions" :value="action"
                >{{label}}</option>
              </select>
            </base-input>
          </div>
    
        </div>
        <!-- ... -->
    
       <base-button slot="footer" type="primary" fill @click="saveCustomer" v-if="!model.id">Salvar</base-button> 
       <base-button slot="footer" type="primary" fill @click="updateCustomer" v-if="model.id">Salvar</base-button> 
      </card>
      </form>
</template>
<script>
  import CustomerDataService from '../../services/CustomerDataService';
  import validate from '../../utils/validations';
  import { states } from '../../utils/contractStatus';
  import { actions } from '../../utils/actions';

  export default {
    props: {
      model: {
        type: Object,
        default: () => {
          return {};
        }
      }
    },
    data() {
      return {
        contractStates: states,
        actions
      }
    },
    methods: {
      notificate(message, type = 'success') {
        this.$notify({ verticalAlign: 'top', horizontalAlign: 'center', message, type });
      },
      saveCustomer() {
        let data = this.model;

        this.$v.$touch()

        if (this.$v.$invalid) {
          return;
        } 

        delete data.id;

        data.document = data.document.replace(/\D/g, "");
        data.phone = data.phone.replace(/\D/g, "");

        CustomerDataService.create(data)
          .then(response => {
            this.notificate('Cliente criado com sucesso!');

            this.$router.push({ path: '/customers'})
          })
          .catch(error => {
            this.notificate('Oops! Ocorreu um erro inesperado.', 'danger');
          })
      },
      updateCustomer() {
        let data = this.model;

        this.$v.$touch()

        if (this.$v.$invalid) {
          return;
        } 

        const id = data.id;

        delete data.id;

        data.document = data.document.replace(/\D/g, "");
        data.phone = data.phone.replace(/\D/g, "");

        CustomerDataService.update(id, data)
          .then(response => {
            this.notificate('Cliente atualizado com sucesso !');

            this.$router.push({ path: '/customers'})
          })
          .catch(error => {
            this.notificate('Oops! Ocorreu um erro inesperado.', 'danger');
          })
      },
      isNumber (evt) {
          const keysAllowed = ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '.'];
          const keyPressed = evt.key;
          
          if (!keysAllowed.includes(keyPressed)) {
                evt.preventDefault()
          }
      }
    },
    computed: {
      title: function() {
        return this.model.id ? `Editar cliente ${this.model.name}` : 'Criar novo cliente';
      }
    },
    validations: validate.create
  }
</script>
<style>
</style>
